# Plugin Facturation pour Paheko (ex Garradin)

Plugin de facturation pour le logiciel de gestion d'association Paheko
( https://paheko.eu/ - https://fossil.kd2.org/paheko ).

Source :
- version compatible paheko 1.3.x : https://git.roflcopter.fr/lesanges/facturation
- version historique non compatible paheko 1.3.x : https://gitlab.com/noizette/garradin-plugin-facturation

## Installation :
Vous pouvez télécharger l'archive .tar.gz depuis la page des
[releases](https://git.roflcopter.fr/lesanges/paheko-plugin-facturation/releases),
supprimer le numéro de version du nom de l'archive puis la placer dans
le dossier plugins de Paheko.

## Fonctionnalités :
- Créer et gérer une base de client·es
- Créer et modifier des factures et devis adressés aux membres de l'association ou des client·es ajouté·es
- (obsolète) Créer des reçus fiscaux pour des dons et génération du CERFA correspondant
- (obsolète) Créer des reçus sur des cotisations
- Génération des documents (facture et devis) en PDF
- Liste les documents associés sur la fiche d'un·e client·e
- Permet de définir le statut du document à « réglé »
- **Configuration** :
    - Possibilité d'ajouter un numéro RNA et SIRET de l'association si elle en possède (apparait alors sur les documents)
	- Possibilité de choisir certains champs à faire figurer sur la facture (adresse, code postal, ville)
    - Modification du pied de page des documents (notamment pour y inscrire des mentions légales)
    - Vérifier le code postal : si coché, lors d'ajout ou de modification de client, le plugin vérifiera que le code postal entré est bien formaté (par rapport aux codes postaux français seulement)
    - Noms de client·es uniques : si coché, lors d'ajout ou de modification de client·e, le nom du/de la client·e ne pourra pas être le même que celui d'un·e client·e déjà existant
    - (obsolète) Informations relatives au CERFA pour les reçus fiscaux
    - (obsolète) Image qui sert de signature sur le CERFA

Note : pour le moment, les actions sur la liste des clients à cocher
ne fonctionnent pas. Pour supprimer un client, le faire depuis sa
fiche.

## Futur de ce plugin :
Un nouveau plugin est en cours de développement par BohwaZ, donc il
n'est pas pertinent d'ajouter de nouvelles fonctionnalités à celui-ci.

Par contre, si des bugs sont signalés sur la liste
hebergement@paheko.cloud ou aide@paheko.cloud, je
(lesanges@zaclys.net) peux tenter de les corriger, à condition que ça
n'impacte pas trop la structure du plugin.

## Futur improbable (obsolète) :
- Ajout des champs Référence, Prix unitaire, Quantité sur les documents
- Actions sur liste de client·es (exporter, supprimer)
- Afficher/filtrer les documents par statuts réglé/archivé
- Changer statut depuis la liste des documents
- Système de template ou jsp pour modifier facilement l'apparence de la facture par l'utilisateur ?
- Petite modif/fix CSS
- Gestion TVA ?
- Un devis ne devrait pas pouvoir être réglé
- Quid si un·e membre de l'asso est supprimé·e alors que des documents lui sont adressés ?
- Opérations de paiements dans la compta liés à une facture
- Gestion de produits

Le plugin nécessite l'extension PHP mbstring.

## (???) Inclus les bibliothèques suivantes :

- Composer :
    https://getcomposer.org/
    Copyright (c) Nils Adermann, Jordi Boggiano,
    Licence: MIT
